
// --------------------------------
// File    : ClientLineSystem.h
// Function: C++ class definition for the Line system effect
// --------------------------------

#ifndef __CLIENTLINESYSTEM_H
#define __CLIENTLINESYSTEM_H

#include "de_client.h"
#include "effect.h"

class ClientLineSystem : public Effect
{
	public:

		ClientLineSystem();
		~ClientLineSystem() { Destroy(); };

		virtual DBOOL	Init(PlayerClient *pPlayer, HLOCALOBJ hObj, DBYTE byType, HMESSAGEREAD hMessage);

		virtual DBOOL	Update();
		virtual void	Destroy();

	protected:

		DBOOL CreateLineSystemObject(ClientDE *pClientDE);

	private :
		DVector		m_vPos;
		DVector		m_vStart;
		DVector		m_vEnd;
		DVector		m_vColor1;
		DFLOAT		m_StartDeltaX,m_StartDeltaY,m_StartDeltaZ;
		DFLOAT		m_EndDeltaX,m_EndDeltaY,m_EndDeltaZ;
		DFLOAT		StartDirection,EndDirection;
		DFLOAT		m_StartAlphaDirection,m_EndAlphaDirection;
};


#endif // __CLIENTLINESYSTEM_H