#ifndef __CLIENTPARTICLESYSTEM_H
#define __CLIENTPARTICLESYSTEM_H

#include "effect.h"
#include "de_client.h"

class ClientParticleSystem : public Effect {
protected:
    float           m_fCycle;
    HLOCALOBJ       m_hParticles;
    HLOCALOBJ       m_hLight;
    int             m_bInited;
    float           m_LightRadius, m_LightDuration;

    ClientDE        *m_pClient;

    DVector m_center_Pos; // Where the Particle Effect center is located

    void    StartSystem(ClientDE *pClient, 
						DVector *mainpos, 
						float lightradius, 
						float lightduration);

    void    DestroySystem();

public:

    ClientParticleSystem() 
	{ 
		m_bInited = 0; 
        m_fCycle  = 0.0f; 

	};
    ~ClientParticleSystem() { DestroySystem(); };

    virtual DBOOL   Init(PlayerClient *pPlayer, HLOCALOBJ hObj, DBYTE byType, HMESSAGEREAD hMessage);

    DBOOL   Update();
    void    Destroy() { DestroySystem(); }

    int     IsInited() { return m_bInited; };
    
};


#endif // __CLIENTPARTICLESYSTEM_H
