// --------------------------------
// File    : Effect.h
// Function: Class definition for base 'Effect' class which all special effects
//         : derive from.
// --------------------------------

#ifndef __EFFECT_H
#define __EFFECT_H

#include "PlayerClient.h"

class Effect
{
    private:
        Effect          *m_pNext, *m_pPrev;

    protected:
        PlayerClient    *m_pPlayer;
        HLOCALOBJ       m_hServerObject, m_hObject;

    public:

        Effect() 
		{ 
			m_pNext = NULL; 
			m_pPrev = NULL; 
		};
        ~Effect() {};
        
        virtual DBOOL   
            Init(	PlayerClient *pPlayer, 
					HLOCALOBJ hObj, 
					DBYTE byType, 
					HMESSAGEREAD hMessage)
                { return DFALSE; };
        
        virtual DBOOL   Update() { return DFALSE; };
        virtual void    Destroy() { return; };

    public:
        virtual Effect  *GetNext()                  { return m_pNext; };
        virtual Effect  *GetPrev()                  { return m_pPrev; };

        virtual void    SetNext(Effect *pEffect)    { m_pNext = pEffect; };
        virtual void    SetPrev(Effect *pEffect)    { m_pPrev = pEffect; };
};

#endif // __EFFECT_H
