// --------------------------------
// File    : EffectsManager.h
// Function: Handles the various special effects; adding, removing and updating them
//         : as appropriate.
// --------------------------------


#ifndef __EFFECTMANAGER_H
#define __EFFECTMANAGER_H

#include "effect.h"

class EffectsManager
{
    protected:
        Effect          *m_pEffects;
        PlayerClient    *m_pPlayer;

    public:
        EffectsManager() { m_pEffects = NULL; m_pPlayer = NULL; };
        ~EffectsManager() { DestroyAll(); }

        void Init(PlayerClient *pPlayer) { m_pPlayer = pPlayer; };
        void Handler(HLOCALOBJ hObj, HMESSAGEREAD hMessage);
        void Update();
        void DestroyAll();

    private:
        void AddEffect(Effect *pEffect);
        void DelEffect(Effect *pEffect);
};

#endif // __EFFECTMANAGER_H
