// Music System Header file
//
// Details:
//     The Music System wrapper for the game

#ifndef __MUSICSYSTEM_H
#define __MUSICSYSTEM_H

#include <BASEDEFS_DE.H>
#include <CPP_ClientShell_de.h>

class cMusic
{
	//Object Properties
    ClientDE *	m_ShellPtr;
    int			m_MusicType;
    int			m_CurrentSong;
    int			m_SongCount;
	short		m_MusicVolume;
    DBOOL		m_MusicPaused;
    char		m_PlayList[255];

  public:
	//Method Definitions
    cMusic();                               // Constructor

	DBOOL init(ClientDE * PtrToShell,
               char *szPathToDLS,
               char *szPlayListName,
               int  MusicType);             // Initialize the music System
                                            // If MusicType is 0 then we are playing CD-Audio
                                            // If MusicType is 1 then we are playing IMA music
    DBOOL AddSong(char * szSongTitle);      // Add a song to the playlist
    DBOOL Begin();                          // Begin Playing a song
    DBOOL Pause();                          // Pause a song
    DBOOL Stop();                           // Stop Playing the song
    DBOOL Skip();                           // Skip the current song
    DBOOL Back();                           // Rewind to the last song
    DBOOL End();                            // No more songs are going to be played.

	void  SetVolume()						// Set the music volume to m_MusicVolume
		{
			m_ShellPtr->SetMusicVolume(m_MusicVolume);
		}
	void JumpUpVolume()					// Increase the Music Volume by 10%
		{
			m_MusicVolume += 10;

			if (m_MusicVolume > 100) m_MusicVolume = 100;

			SetVolume();
		}
	void JumpDownVolume()					// Decrease the Music Volume by 10%
		{
			m_MusicVolume -= 10;

			if (m_MusicVolume < 0) m_MusicVolume = 0;

			SetVolume();
		}

	void SkipUpVolume()					// Increase the Music Volume by 1%
		{
			m_MusicVolume ++;

			if (m_MusicVolume > 100) m_MusicVolume = 100;

			SetVolume();
		}

	void SkipDownVolume()					// Decrease the Music Volume by 1%
		{
			m_MusicVolume --;

			if (m_MusicVolume < 0) m_MusicVolume = 0;

			SetVolume();
		}

};

#endif
