
#ifndef __SAMPLE_CLIENTSHELL_H__
#define __SAMPLE_CLIENTSHELL_H__

enum eGameState {GAME_PAUSED,GAME_MOVIE,GAME_PLAYING,GAME_OVER,GAME_MENU,GAME_LOADLEVEL};

class CSampleClientShell : public CClientShellDE
{
	public:
		CSampleClientShell();

		// Overrides from CClientShellDE.
		virtual DRESULT OnEngineInitialized(struct RMode_t *pMode, DGUID *pGuid);
		virtual void Update();

		virtual void OnEnterWorld();
		virtual void OnExitWorld();

        virtual void OnKeyDown(int key, int rep);
        virtual void OnCommandOn(int command);

        virtual void SpecialEffectNotify(HLOCALOBJ hObj, HMESSAGEREAD hMessage);
		virtual void OnMessage(DBYTE messageID, HMESSAGEREAD hMessage);
			
        void UpdatePlayer();

        eGameState      m_nGameState;
		HLOCALOBJ		m_hCamera;
		PlayerClient    m_Player;
        EffectsManager  m_EffectsMgr;
        cMusic			m_MusicTracker;

    private:
        void PlayMovie(CClientDE* pClientDE, char * szMovieName);
        void UpdateMoviesState();
};

#endif  // __SAMPLE_CLIENTSHELL_H__




