
// player.h defines the Player class, which represents a client in the world.

#ifndef __PLAYER_H__
#define __PLAYER_H__

enum ePlayerState {PLAYER_ALIVE,PLAYER_DEAD};

class Player : public BaseClass
{
	public:
		Player::Player()			// Inline Constructor
		{
			m_ReAnimate_Timer = 0;
		}

		DDWORD EngineMessageFn(DDWORD messageID, void *pData, DFLOAT lData);
		DDWORD ObjectMessageFn(HOBJECT hSender, DDWORD messageID, HMESSAGEREAD hRead);
		bool OnSolid();

		void ReStartPlayer();

		// The client associated with this player.
		HCLIENT	m_hClient;

        // indexes for animations
        DDWORD m_WalkIndex;
        DDWORD m_StandIndex;
        DDWORD m_JumpIndex;
        DDWORD m_CurrentAnimationIndex;

		bool			m_bPlayerInAir;
		ePlayerState	m_ePlayerState;
		DDWORD			m_ReAnimate_Timer;
		DVector			m_PlayersDeathSpot;

		long   m_Score;
};


#endif  // __PLAYER_H__

