// waterBrush.cpp
// Description
//    Source code that contains the implementation of a Water object
// Revisions
//

#include "de_server.h"
#include "sample_servershell.h"
#include "WaterBrush.h"
#include <stdio.h>

cWaterBrush::cWaterBrush() : BaseClass(OT_WORLDMODEL)
{
}

cWaterBrush::~cWaterBrush()
{
}

DDWORD cWaterBrush::EngineMessageFn(DDWORD messageID, void *pData, DFLOAT lData)
{
    ObjectCreateStruct *pObjectCreateStruct;
    DVector temp1,ObjPos;

    DDWORD dwRet = BaseClass::EngineMessageFn(messageID, pData, lData);

    // See serverobj_de.h (near line 100) for descriptions of the messages.
    switch(messageID)
    {
        case MID_PRECREATE:
        {
			// There really isn't anything to read in.  So we go on to create an instance of
			// the object
			pObjectCreateStruct = (ObjectCreateStruct*)pData;
            strcpy(pObjectCreateStruct->m_Filename, pObjectCreateStruct->m_Name);
            pObjectCreateStruct->m_SkinName[0] = '\0';
            pObjectCreateStruct->m_Flags |= FLAG_TOUCH_NOTIFY | FLAG_BOXPHYSICS | FLAG_FULLPOSITIONRES;

            break;

        }

        case MID_INITIALUPDATE:
        {
            GetServerDE()->SetNextUpdate(m_hObject, 0.10f);
            // Tell Lithtech to update us pretty soon (give the doors a bit of a delay in opening.
            GetServerDE()->SetForceIgnoreLimit(m_hObject,1);

            break;
        }

        case MID_UPDATE:
        {
            GetServerDE()->SetNextUpdate(m_hObject, 0.1f);

            break;
        }

        // This is called when another object touches this object.
        // pData is an HOBJECT for the other object.
        // fData is the collision (stopping) force (based on masses and velocities).
        case MID_TOUCHNOTIFY:
        {
			HMESSAGEWRITE hWrite;

            // Send a "You're dead" message to the player object
			// Send the point value of this coin to the Player
			hWrite = GetServerDE()->StartMessageToObject(this,(HOBJECT)pData,21);

			GetServerDE()->EndMessage(hWrite);

            GetServerDE()->SetNextUpdate(m_hObject, 1.0f);

            break;
        }
    }

    // Pass the message on down.
    return dwRet;
}

// Expose the Water Brush class for DEdit.
BEGIN_CLASS(cWaterBrush)
    ADD_VISIBLE_FLAG(1, 0)
    ADD_SOLID_FLAG(0, 0)
	ADD_TOUCHNOTIFY_FLAG(1,0)
END_CLASS_DEFAULT_FLAGS(cWaterBrush, BaseClass, NULL, NULL, 0)
