// PlayerClient.H
// Description: The Player Object On the Client
// Function:	Creates a Player object on the client.  
//              This is something different than the Client on the
//              Server, as this is an object that we can use for
//				Grouping of Client Rendering functions (The HUD,
//				ChaseCam, etc).

#ifndef __PLAYERCLIENT_H
#define __PLAYERCLIENT_H
#include "cHUD.h"
#include "ChaseCam.h"

class PlayerClient
{
    protected:
        HLOCALOBJ   m_hCamera;  // Handle to camera.
        ClientDE    *m_pClient; // Handle to ClientDE.

        float         m_Yaw, m_Pitch, m_Roll;
        float         m_cYaw, m_cPitch, m_cRoll;

        DBOOL         m_bCameraLocked;
        float         m_fDistance, m_fOffset;
        ChaseCam      m_ChaseCam;

    public:
        PlayerClient();
        ~PlayerClient();

        void        Init(ClientDE *pClient);

        HLOCALOBJ   GetCamera() { return m_ChaseCam.GetCamera(); };
        ClientDE*   GetClient() { return m_pClient; };

        void        SetCamera(HLOCALOBJ hObj) { m_ChaseCam.SetCamera(hObj); };

        void        Update();
        void        OnCommandOn(int command);

		// HUD Display
		cHUD *  HUD;

};

#endif // end #ifndef __PLAYERCLIENT_H

