// On-screen System Heads Up Display Header file
// 
// Details:
//     The Heads Up Display (HUD) for the game in progress
//     
//     

#ifndef __CHUD_H
#define __CHUD_H

#include <BASEDEFS_DE.H>
#include <CPP_ClientShell_de.h>

typedef struct
{
	DDWORD ScreenWidth, ScreenHeight;
	DDWORD MidScreenWidth, MidScreenHeight;
} tDisplayStats;

class cGameMessageWindow
{
 // Method Definition
 public:
     cGameMessageWindow();                  // Default Constructor
     ~cGameMessageWindow();                 // Default Destructor

     DBOOL Init(ClientDE * ClientShell,
                  int left, int top);       // Initialize the Debug system
     DBOOL AddString(char *NewString);		// Add a string to the display
     DBOOL Render();                        // Render the Debug window

   // Variable definition
   private:
    DRect   OuterRect,                      // Outer Rectangle defines the Debug window
            InnerRect;                      // Innder Rectangle defines the Text Area
    int NumberofTextLines;					// The number of lines of text
    HDEFONT DisplayFont;                    // The Debug font
    struct
    {
            int x;
            int y;
    }TopCorner;                             // Position of the top corner of the debug 
											// window
//    char StringDisplay[9][50];              // The text to display
    char StringDisplay[5][50];              // The text to display
    int FontWidth,FontHeight;               // The width and the height of the font.
    ClientDE * ClientShellDEPtr;			// Pointer to the ClientShellDE
    HDECOLOR ForeFontColor, BackFontColor;
};

class cHUD
{
	//Object Properties
	HSURFACE PrimarySurface;
	HSURFACE hsHUDArt;
	ClientDE * ShellPtr;
	tDisplayStats * DisplayStats;

  public:
	//Method Definitions
	cHUD();										//Default Constructor

	DBOOL init(ClientDE * PtrToShell,
			   char *szFilename,
			   HSURFACE DisplaySurf,
			   tDisplayStats * Display);				//Initialize the HUD

	DBOOL Render();										//Render the HUD to the Screen

	cGameMessageWindow GameMessage;
};

#endif
