// CHASECAM.H
// Description: Chase Cam Object
// Function:	Creates a Chase Cam object.  This code is Inspired
//              by the LokiCam object. Created by Jeremy Blackman
//              at Monolith.  Which was, in turn, inspired by one
//              my tutorials.

#ifndef __CHASECAM_H
#define __CHASECAM_H

#define MAXCAMERAS 1

class ChaseCam {
protected:

    DRotation   m_CameraRotation;
    DVector     m_CameraPos;
    float       m_CameraZoom;
    float       m_Yaw, m_Roll, m_Pitch;
    float       m_Offset;
    HLOCALOBJ   m_hTarget;
    HLOCALOBJ   m_hCamera;
    DBOOL       m_bWasBlocked;
    float       m_fSteps, m_fCurrentStep;
    ClientDE    *m_pClientDE;
	int			m_CameraMode;
    
public:
    ChaseCam();
    ~ChaseCam();

    void                    Init(ClientDE *pClient);

    HLOCALOBJ               GetCamera() { return m_hCamera; };
    DRotation               GetRotation() { return m_CameraRotation; };
	int						GetCameraMode() {return m_CameraMode;};

    void                    SetCamera(HLOCALOBJ hCam) { m_hCamera = hCam; };
	void					NextCamera();

    void                    Zoom(float delta);
    
    void                    Update();

    // Commands for free form camera
    void                    UpdateOffset(float delta);
    void                    UpdateYaw(float delta);
    void                    UpdateRoll(float delta);
    void                    UpdatePitch(float delta);

private:
    void                    UpdateRelative();
	void					UpdateFreeform();
    
};

#endif  // end #ifndef __CHASECAM_H

